function varargout = Main_Program(varargin)
%% In this file you find the implementation of the GUI 
% Source Files to the Paper:
% "A Cellular Automaton model as a first model-based access to interacting 
%  mechanisms for insulin granule transport in beta cells"
% Michael Mller, Mathias Glombek, Jeldrick Powitz, Dennis Brning, Ingo
% Rustenbeck
%%%%%%%%%% Technische Universitt Braunschweig %%%%%%%%%%%%%%%%%%%%%%%%%%%


% Last Modified by GUIDE v2.5 11-Jun-2020 12:56:57

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Main_Program_OpeningFcn, ...
                   'gui_OutputFcn',  @Main_Program_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Main_Program is made visible.
function Main_Program_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Main_Program (see VARARGIN)
% set ( 0, 'DefaultFigureColor', [1 1 1] )

%=====start picture ==========================
pic = imread('title_pic.jpg');
axes(handles.axes1);
imshow(pic);

% === Specifications for the 3D-Model ========
% Size of domain
x = 70;
y = 70;
z = 70;
set(handles.editm,'string',num2str(x));
set(handles.editn,'string',num2str(y));
set(handles.editz,'string',num2str(z));
set(handles.tirf_t,'string',num2str(z));
% Initialisation of domain matrix
ZA3 = zeros(x,y,z,2);
handles.ZA3 = ZA3;
handles.Experiment = 0;

% reset(handles.axes3) 

% Choose default command line output for Main_Program
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Main_Program wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Main_Program_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



% --- Executes on button press in move.
function move_Callback(hObject, eventdata, handles)
% test button
fh = figure;
mymap = [0 0 0
    1 0 0
    1 0 0
    1 0 0];
colormap(mymap);
copyobj(handles.axes1, fh);



function editm_Callback(hObject, eventdata, handles)
% hObject    handle to editm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editm as text
%        str2double(get(hObject,'String')) returns contents of editm as a double


% --- Executes during object creation, after setting all properties.
function editm_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editn_Callback(hObject, eventdata, handles)
% hObject    handle to editn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editn as text
%        str2double(get(hObject,'String')) returns contents of editn as a double


% --- Executes during object creation, after setting all properties.
function editn_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in tabsize.
function tabsize_Callback(hObject, eventdata, handles)
% hObject    handle to tabsize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% === Eingabe auslesen ==
m = get(handles.editm,'string');
m = str2num(m);
n = get(handles.editn,'string');
n = str2num(n);
z = get(handles.editz,'string');
z = str2num(z);

% === Werte verarbeiten ===
set(handles.uitable1,'Data',cell(m,n));
set(handles.uitable1,'Data',zeros(m,n));
set(handles.tirf_t,'string',num2str(z));

% === 2D ===
ZA = zeros(m,n,4);
handles.ZA = ZA;

% === 3D ===
% try
ZA3 = zeros(m,n,z,2);
handles.ZA3 = ZA3;
% end
  
colormap(handles.mymap);
imagesc(ZA(:,:,1));
guidata(hObject,handles);


% --- Executes on button press in start_con_3d.
function start_con_3d_Callback(hObject, eventdata, handles)
% hObject    handle to start_con_3d (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%% function to set start conditions
%====states
fluid=0;
aktin=1;
gran=2;

% === resest current image ===
axes(handles.axes1); 
cla reset; % Do a complete and total reset of the axes.

ZA3 = handles.ZB3;
[x,y,z] = size(ZA3(:,:,:,1));

time = 15;     %determine ripeness

% === Goes through all matrix elements INSIDE the cell/domain and places granules ===
for i=2:x-1
    for j=2:y-1
        for k =2:z-1
            if(ZA3(i,j,k,1)~=aktin)
                if rand < 13000/(x*y*z)         % 13.000 Granules per Beta-Zell
                    if rand < 0.88              % 88% are diffusive or stationary granules
                        ZA3(i,j,k,1)=2; 
                    else                        % 12% are directed moving granulues
                        ZA3(i,j,k,1)=randi([5 10]);
                    end
                    ZA3(i,j,k,2) = randi([0 time]);
                    if rand < 0.05              % 5% are readily releasable
                        ZA3(i,j,k,2) = time+1;
                    end
                end
            end
            
        end
    end
end


% === Goes through all edges of the cell/domain ===
for i=1:x 
    for j=1:y
        for k=1:z
            %Checking, if on edge of domain, otherwise continue
            if i==1 || i==x || j==1 || j==y || k==1 || k==z
                if rand < 13000/(x*y*z)         
                    ZA3(i,j,k,1) = 11;
                    if rand < 0.05   % 5% Readily Releasable
                        ZA3(i,j,k,2) = time + 1;
                    else
                        ZA3(i,j,k,2) = randi([0 time]);
                    end
                end
            else
                continue
            end  
        end
    end
end

% === Determination of number and distribution of created granules ===
sz = [x y z];
vec1 = find(ZA3(:,:,:,1)==1);
[i1,j1,k1] = ind2sub(sz,vec1);

vec2 = find(ZA3(:,:,:,1)==2);
[i2,j2,k2] = ind2sub(sz,vec2);

vec3 = find(ZA3(:,:,:,1)==4);
[i3,j3,k3] = ind2sub(sz,vec3);

vec4 = find((ZA3(:,:,:,1)>4) & (ZA3(:,:,:,1)<11));
[i4,j4,k4] = ind2sub(sz,vec4);

vec5 = find(ZA3(:,:,:,1)==3);
[i5,j5,k5] = ind2sub(sz,vec5);

vec6 = find(ZA3(:,:,:,1)==11);
[i6,j6,k6] = ind2sub(sz,vec6);

anzgran = length(vec2) + length(vec3) + length(vec4) + length(vec5) + length(vec6);
handles.anzgran = anzgran;
disp(['Number of granules at start: n_nom = ' num2str(anzgran)]);

% === granule plotting ===
hold on
view(3);
ax = handles.axes1;
h = scatter3(ax,i1,j1,k1,80,'s',...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor',[1 0 0]);
alpha(h,0.1);

b = scatter3(ax,i2,j2,k2,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor',[0 0.5 0]);
d =scatter3(ax,i3,j3,k3,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor',[0.4 0.9 0.1880]);

e = scatter3(ax,i4,j4,k4,'filled',...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','b');
f = scatter3(ax,i5,j5,k5,'filled',...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','y');

g = scatter3(ax,i6,j6,k6,'filled',...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor',[0 1 1]);


alpha(h,0.1);
rotate3d on
hold off

% === Save ZA as struct ===
handles.ZA3 = ZA3;
pause(0.2);
guidata(hObject,handles);


% --- Executes on button press in automat.
function automat_Callback(hObject, eventdata, handles)
% hObject    handle to automat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%% this is the toggle button to start/stop the 3D Simulation

% === Plots ===
lol = animatedline(handles.axes2); %axes2
gluc_line = animatedline(handles.axes2,'Color','g'); %axes2
kali_line = animatedline(handles.axes2,'Color','b'); %axes2
Stimulation_line = animatedline(handles.axes2,'Color','r'); %axes2
lol4 = animatedline(handles.axes5);
plot1 = animatedline(handles.axes6); 
plots = zeros(2500,5);


% === Read in the current values for Glucose, Kalium, Number of granules...
anzgran = handles.anzgran;
granules = anzgran;
handles.gluc_start = get(handles.slider_gluco, 'Value');
handles.kali_start = get(handles.slider_kali, 'Value');
handles.zaehler = 1;
handles.gluc_soll = handles.gluc_start;  
handles.kali_soll = handles.kali_start; 
handles.Stimulation_ist = 0;
handles.StartStimu = 0.005;
counter_Stimu = 0;
handles.counter_Stimu = counter_Stimu;
handles.t = 1;


% ================================
while( get(hObject,'Value'))
    % === Read out current counters ===
    try %count
        count = handles.count;
    catch
        count = 0;
    end
    

    cla reset; % Do a complete and total reset of the axes; handle visibility off, if not to be reseted

    % === Read out current values ===
    ZA3 = handles.ZA3;
    ZB3 = handles.ZB3;   %here "AktinNetz" is transferred, does not change
    [x,y,z] = size(ZA3(:,:,:,1));
    
    % === Determine stimulation ===
    counter_Stimu = handles.counter_Stimu;
    
    if handles.gluc_soll == get(handles.slider_gluco, 'Value') && handles.kali_soll == get(handles.slider_kali, 'Value')
        counter_Stimu = counter_Stimu + handles.zaehler;
        StartStimu = handles.StartStimu;
        handles.t = handles.t+1;
    else
        handles.gluc_soll = get(handles.slider_gluco, 'Value');
        handles.kali_soll = get(handles.slider_kali, 'Value');
        counter_Stimu = 0;
        handles.t = 1;
        StartStimu = handles.Stimulation_ist;     
    end
  
    handles.StartStimu = StartStimu;
    handles.counter_Stimu = counter_Stimu;
    
    anzgran = handles.anzgran;
    
    
    %=================================================================================================================
    [A3,insulin,handles.Stimulation_ist] = Automaton_Function(ZA3,ZB3,handles.gluc_soll,handles.kali_soll,StartStimu,handles.t,anzgran,granules); 
    %=================================================================================================================

    
    % === Determination of the number and distribution of the granules ===
    sz = [x y z];
    vec1 = find(ZB3(:,:,:,1)==1);
    [i1,j1,k1] = ind2sub(sz,vec1);

    vec2 = find(A3(:,:,:,1)==2);
    [i2,j2,k2] = ind2sub(sz,vec2);

    vec3 = find(A3(:,:,:,1)==4);
    [i3,j3,k3] = ind2sub(sz,vec3);
    
    vec4 = find((A3(:,:,:,1)>4) & (A3(:,:,:,1)<11));
    [i4,j4,k4] = ind2sub(sz,vec4);

    vec5 = find(A3(:,:,:,1)==3);
    [i5,j5,k5] = ind2sub(sz,vec5);

    vec6 = find(A3(:,:,:,1)==11);
    [i6,j6,k6] = ind2sub(sz,vec6);

    % === viewing depth t ===
    try
        t = get(handles.tirf_t,'string');
        t = str2num(t);
        if t > z
            t = z;
            set(handles.tirf_t,'string',num2str(t));
        elseif t < 1
            t = 1;
            set(handles.tirf_t,'string',num2str(t));
        end
    catch
        t = z; %may not exceed z 
    end
    if handles.Experiment == 2 || handles.Experiment == 3 || handles.Experiment == 4  % Experiments
        t = 8;
        set(handles.tirf_t,'string',num2str(t));
    end
    
    vec_tirf = find(A3(:,:,1:t,1)>1);

    if count == 0
        handles.alt_tirf = length(vec_tirf);
    end

    anzgran = length(vec2) + length(vec4) + length(vec3) + length(vec5) + length(vec6);  %current number of granules
    handles.anzgran = anzgran;              %current number of granules
    anzgranRandschicht = size(vec_tirf,1);  %Number of granules to viewing depth t (for TIRF images)


    % == Checking the set view ===
    try
        switch get(handles.popupmenu1, 'UserData')
            case 1
                view(3);
            case 2
                view(2);
            otherwise
                view(120,30);
        end
        catch
            view(3);
    end

    % === Drawing the 3D view ===
    ax = handles.axes1;
    hold on
    if ~get(handles.actin_onoff,'Value')    %Check if actin should be displayed
        h = scatter3(ax,i1,j1,k1,80,'s',...
            'MarkerEdgeColor','k',...
            'MarkerFaceColor',[1 0 0]);   % Wert = 1
        alpha(h,0.1);
    end
    b = scatter3(ax,i2,j2,k2,...
        'MarkerEdgeColor','k',...
        'MarkerFaceColor',[0 0.5 0]);    % Wert = 2
    d = scatter3(ax,i3,j3,k3,...
        'MarkerEdgeColor','k',...
        'MarkerFaceColor',[0.4 0.9 0.1880]);   % Wert = 4
    e = scatter3(ax,i4,j4,k4,'filled',...
        'MarkerEdgeColor','k',...
        'MarkerFaceColor','b');   % Wert = 5-10
    f = scatter3(ax,i5,j5,k5,'filled',...
        'MarkerEdgeColor','k',...
        'MarkerFaceColor','y');   % Wert = 3
    f = scatter3(ax,i6,j6,k6,'filled',...
        'MarkerEdgeColor','k',...
        'MarkerFaceColor',[0 1 1]);  % Wert = 11

    hold off

    % === Incrementing the control variable ====================
    count = count + 1;
    % ==========================================================

    
    glucose = get(handles.slider_gluco, 'Value');
    kalium = get(handles.slider_kali, 'Value');
    
    
    % === draw plots ===
    addpoints(lol,count,insulin);                %draw insulin
    addpoints(lol4,count,anzgran/(x*y*z)*100);   %Granules in percent auf cell-size related
    addpoints(plot1,count,anzgranRandschicht);   %plot1=axes6

    plots(count,1) = insulin;
    plots(count,2) = anzgran/(x*y*z)*100;
    plots(count,3) = anzgranRandschicht;
    plots(count,4) = glucose;
    plots(count,5) = kalium;

    addpoints(gluc_line,count,glucose*100);      %target Glucose in insulin-plot
    addpoints(kali_line,count,kalium*100);       %target Kalium in insulin-plot
    addpoints(Stimulation_line,count,handles.Stimulation_ist*100); %Stimulation in insulin-plot
    
    drawnow
    
    
    % === Check if/what experiment is to be evaluated === 
    if handles.Experiment == 1  % Biphasic behaviour
        if count <= 100
            set(handles.slider_gluco,'Value',5/100);
        elseif count > 100 && count <= 500
            set(handles.slider_gluco,'Value',1);
        elseif count > 500 && count <= 650
            set(handles.slider_gluco,'Value',5/100);
        elseif count > 650
            set(handles.automat,'Value',0);
            AuswertungPlotten(handles.Experiment,Auswertung);
        end
        
        Auswertung(count,1) = insulin;
        Auswertung(count,2) = glucose;
        
    elseif handles.Experiment == 2 % first Kalium then Glucose stimulation
        set(handles.tirf_t,'String','8');
        if count <= 100
            set(handles.slider_gluco,'Value',0);
        elseif count > 100 && count <=200
            set(handles.slider_kali,'Value',40/100);
        elseif count > 200 && count <=300
            set(handles.slider_kali,'Value',0);
        elseif count > 300 && count <=400
            set(handles.slider_gluco,'Value',30/100);
        elseif count > 400 && count <=500
            set(handles.slider_gluco,'Value',0);
        elseif count > 500
            set(handles.automat,'Value',0);
            AuswertungPlotten(handles.Experiment,Auswertung);
        end
        
        Auswertung(count,1) = insulin;
        Auswertung(count,2) = anzgranRandschicht;
        Auswertung(count,3) = glucose;
        Auswertung(count,4) = kalium;
        
    elseif handles.Experiment == 3 % first Glucose then Kalium stimulation
        set(handles.tirf_t,'String','8');
        if count <= 100
            set(handles.slider_gluco,'Value',3/100);
        elseif count > 100 && count <=200
            set(handles.slider_gluco,'Value',30/100);
        elseif count > 200 && count <=300
            set(handles.slider_gluco,'Value',3/100);
        elseif count > 300 && count <=400
            set(handles.slider_kali,'Value',40/100);
            set(handles.slider_gluco,'Value',0);
        elseif count > 400 && count <=500
            set(handles.slider_kali,'Value',0);
            set(handles.slider_gluco,'Value',3/100);
        elseif count > 500
            set(handles.automat,'Value',0);
            AuswertungPlotten(handles.Experiment,Auswertung);
        end
        
        Auswertung(count,1) = insulin;
        Auswertung(count,2) = anzgranRandschicht;
        Auswertung(count,3) = glucose;
        Auswertung(count,4) = kalium;
        
    elseif handles.Experiment == 4 %control stimulus
        set(handles.tirf_t,'String','8');
        if count <= 500
            set(handles.slider_gluco,'Value',3/100);
        elseif count > 500
            set(handles.automat,'Value',0);
            AuswertungPlotten(handles.Experiment,Auswertung);
        end
        
        Auswertung(count,1) = insulin;
        Auswertung(count,2) = glucose;
        Auswertung(count,3) = anzgranRandschicht;
        
    elseif handles.Experiment == 5 %Test
        if count <= 100
            set(handles.slider_gluco,'Value',0.25);
            set(handles.slider_kali,'Value',0);
        elseif count > 100 && count <= 200
            set(handles.slider_gluco,'Value',0);
        elseif count > 200 && count <= 300
            set(handles.slider_kali,'Value',0.25);
        elseif count > 300 && count <= 400
            set(handles.slider_kali,'Value',0);
        elseif count > 400 && count <= 500
            set(handles.slider_gluco,'Value',0.15);
            set(handles.slider_kali,'Value',0.07);
        elseif count > 500 && count <= 600
            set(handles.slider_gluco,'Value',0);
            set(handles.slider_kali,'Value',0);
        elseif count > 700
            set(handles.automat,'Value',0);
            AuswertungPlotten(handles.Experiment,Auswertung);
        end
        
        Auswertung(count,1) = glucose;
        Auswertung(count,2) = kalium;
        Auswertung(count,3) = handles.Stimulation_ist;
        
    elseif handles.Experiment == 6 %Test
        if count <= 10
            set(handles.slider_gluco,'Value',5/100);
        elseif count > 10 && count <= 40
            set(handles.slider_gluco,'Value',1);
        elseif count > 40 && count <= 60
            set(handles.slider_gluco,'Value',5/100);
        elseif count > 60
            set(handles.automat,'Value',0);
            AuswertungPlotten(handles.Experiment,Auswertung);
        end
        
        Auswertung(count,1) = insulin;
        Auswertung(count,2) = glucose;
    end
    
    

    % === Update and Safe ===
    handles.count = count;
    handles.plots = plots; 
    handles.ZA3 = A3;
    handles.glucose = glucose;
    handles.kalium = kalium;
    guidata(hObject,handles);
    pause(0.05);
end



% --- Executes on button press in actin_create_3d.
function actin_create_3d_Callback(hObject, eventdata, handles)
% hObject    handle to actin_create_3d (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%Control query
answer = questdlg('Are all parameters set within the script?', ...
        'visualization','yes','no','no');
if strcmp(answer,'no')
  edit CreateActin.m
elseif strcmp(answer,'yes')
  CreateActin()
end



% --- Executes on button press in actin_onoff.
function actin_onoff_Callback(hObject, eventdata, handles)
% hObject    handle to actin_onoff (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1
switch get(handles.popupmenu1,'Value')
    case 1
        v = 1;
    case 2
        v = 2;
    otherwise
        v = 3;
end
set(handles.popupmenu1, 'UserData', v);


% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_Import.
function pushbutton_Import_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Import (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%momentanes Bild reseten
axes(handles.axes1); 
cla reset; % Do a complete and total reset of the axes.

A = handles.ZA3;
[x,y,z] = size(A(:,:,:,1));

ZA = zeros(x,y,z,2);

%manuell: ZA(:,:,:,1) = importdata('.\Netz3_70_70_70.mat'); %('Netz1_70_70_70.mat');
%automatic (load file, checking size, import):
[file,path] = uigetfile('*.mat',['Zellengre: ' int2str(x) ' x ' int2str(y) ' x ' int2str(z)],'.\Default Actin Networks');
if file == 0
    return
else
    ZALoaded = importdata([path file]);
    [xLoaded,yLoaded,zLoaded] = size(ZALoaded);
    if xLoaded ~= x || yLoaded ~= y || zLoaded ~= z
        %warndlg('Achtung, falsche Zellengre gewhlt!','Warning');
        x = xLoaded;
        y = yLoaded;
        z = zLoaded;
        set(handles.editm,'string',num2str(x));
        set(handles.editn,'string',num2str(y));
        set(handles.editz,'string',num2str(z));
        set(handles.tirf_t,'string',num2str(z));
        clear ZA
        ZA = zeros(x,y,z,2);
        ZA(:,:,:,1) = ZALoaded;
    else
        ZA = zeros(x,y,z,2);
        ZA(:,:,:,1) = ZALoaded;
    end
    clear ZALoaded xLoaded yLoaded zLoaded
end

%loaded mat-File rewrite
for i = 1:x
    for j = 1:y
        for k = 1:z
            if ZA(i,j,k,1) == 0
                ZA(i,j,k,1) = 1;
            else 
                ZA(i,j,k,1) = 0;
            end
        end
    end
end
sz = [x y z];
vec1 = find(ZA(:,:,:,1)==1);
[i1,j1,k1] = ind2sub(sz,vec1);

%Presentation in Figure
view(3);
hold on
h = scatter3(i1,j1,k1,80,'s',...
    'MarkerFaceColor',[1 0 0],...     
    'MarkerEdgeColor','k');
     
alpha(h,0.3);
rotate3d on
hold off

%Save ZA as struct
handles.ZB3 = ZA;
handles.ZA3 = ZA;
guidata(hObject,handles);


% --- Executes on slider movement.
function slider_gluco_Callback(hObject, eventdata, handles)
% hObject    handle to slider_gluco (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function slider_gluco_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_gluco (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider_calc_Callback(hObject, eventdata, handles)
% hObject    handle to slider_calc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function slider_calc_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_calc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider_kali_Callback(hObject, eventdata, handles)
% hObject    handle to slider_kali (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function slider_kali_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_kali (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function editz_Callback(hObject, eventdata, handles)
% hObject    handle to editz (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editz as text
%        str2double(get(hObject,'String')) returns contents of editz as a double


% --- Executes during object creation, after setting all properties.
function editz_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editz (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider_latrun_Callback(hObject, eventdata, handles)
% hObject    handle to slider_latrun (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function slider_latrun_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_latrun (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in latrun.
function latrun_Callback(hObject, eventdata, handles)
% hObject    handle to latrun (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
latrun = get(handles.slider_latrun, 'Value');
ZB = handles.ZB3;
[x,y,z] = size(ZB(:,:,:,1));
C = ZB;

flag = 0;
for i = 1:x
    for j = 1:y
        for k = 1:z
            if ZB(i,j,k,1) == 1
                for m = -1:1  
                    for n = -1:1
                        for l = -1:1
                            try 
                                if ZB(i+m,j+n,k+l,1) == 0 && rand < latrun
                                    flag = 1;
                                end
                            end
                        end
                    end
                end
                if flag == 1
                    C(i,j,k,1) = 0;
                    flag = 0;
                end
            end
        end
    end
end  

%==== draw
sz = [x y z];
vec1 = find(C(:,:,:,1)==1);
[i1,j1,k1] = ind2sub(sz,vec1);

h = scatter3(i1,j1,k1,80,'s',...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor',[1 0 0]);
alpha(h,0.1);
                                    
handles.ZB3 = C;
guidata(hObject, handles);


% --- Executes on button press in chord_length_3d.
function chord_length_3d_Callback(hObject, eventdata, handles)
% hObject    handle to chord_length_3d (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
B = handles.ZB3;

[chl_x,chl_y,chl_z,chd_x,chd_y,chd_z] = chord_length_3d(B(:,:,:,1));  %Determine chord length distribution
[x,y,z] = size(B(:,:,:,1));

% === Determine density ===
akt = 0;
for i = 1:x
    for j = 1:y
        for k = 1:z
            if B(i,j,k) == 1
            	akt = akt + 1;
            end
        end
    end
end

anz = x*y*z;         %size of the cube
rho = akt/anz;       %densitiy
disp(['Dichte:  rho = ' num2str(rho)]);

disp('Durchschnittslngen der Chords');
chd_x
chd_y
chd_z

% === draw plots ===
figure('Name',['Dichte Aktinnetz: rho = ' num2str(rho)]);
hold on
plot(chl_x,'b','linewidth',1);
plot(chl_y,'m','linewidth',1);
plot(chl_z,'g','linewidth',1);
hold off
xlabel('Lnge');
ylabel('Anzahl');
legend('x-Direction','y-Direction','z-Direction');
title(['xd=' num2str(round(chd_x*100)/100) ' (' num2str(chd_x/x*100) '%)'...
    '    yd=' num2str(round(chd_y*100)/100) ' (' num2str(chd_y/y*100) '%)'...
    '    zd=' num2str(round(chd_z*100)/100) ' (' num2str(chd_z/z*100) '%)']);

set(gca,'YLim',[0 1400]);


% --- Executes on button press in tirf.
function tirf_Callback(hObject, eventdata, handles)
% hObject    handle to tirf (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of tirf
% === plot drawing ===    
lol = animatedline(handles.axes2);
gluc_line = animatedline(handles.axes2,'Color','g');
kali_line = animatedline(handles.axes2,'Color','b');
Stimulation_line = animatedline(handles.axes2,'Color','r'); %axes2
plots = zeros(2500,5);



% === Read in the current values for Glucose, Kalium, granules...
anzgran = handles.anzgran;
granules = anzgran;
handles.gluc_start = get(handles.slider_gluco, 'Value');
handles.kali_start = get(handles.slider_kali, 'Value');
handles.zaehler = 1;
handles.gluc_soll = handles.gluc_start;  
handles.kali_soll = handles.kali_start; 
handles.Stimulation_ist = 0;
handles.StartStimu = 0.005;
counter_Stimu = 0;
handles.counter_Stimu = counter_Stimu;
handles.t = 1;


% ================================
while( get(hObject,'Value') )
    % === Read out current counters ===
    try
        count = handles.count;
    catch
        count = 0;
    end


    cla reset; % Do a complete and total reset of the axes; handle visibility off, if not to be reseted

% === Read out current values ===
ZA3  = handles.ZA3;
ZB = handles.ZB3;   %here "AktinNetz" is transferred, does not change
[x,y,z] = size(ZA3(:,:,:,1));

% === Determine stimulation ===
counter_Stimu = handles.counter_Stimu;
    
    if handles.gluc_soll == get(handles.slider_gluco, 'Value') && handles.kali_soll == get(handles.slider_kali, 'Value')
        counter_Stimu = counter_Stimu + handles.zaehler;
        StartStimu = handles.StartStimu;
        handles.t = handles.t+1;
    else
        handles.gluc_soll = get(handles.slider_gluco, 'Value');
        handles.kali_soll = get(handles.slider_kali, 'Value');
        counter_Stimu = 0;
        handles.t = 1;
        StartStimu = handles.Stimulation_ist;     
    end
  
    handles.StartStimu = StartStimu;
    handles.counter_Stimu = counter_Stimu;
    
    anzgran = handles.anzgran;

%================================================================================================================
[A3,insulin,handles.Stimulation_ist] = Automaton_Function(ZA3,ZB,handles.gluc_soll,handles.kali_soll,StartStimu,handles.t,anzgran,granules); 
%================================================================================================================

% === Durchscheintiefe t ===
try
    t = get(handles.tirf_t,'string');
    t = str2num(t);
    if t > z
        t = z;
        set(handles.tirf_t,'string',num2str(t));
    elseif t < 1
        t = 1;
        set(handles.tirf_t,'string',num2str(t));
    end
catch
    t = z; % t may not exceed z
end

% === Determination of the number and distribution of the granules ===
sz = [x y z];

vec1 = find(ZB(:,:,1:t,1)==1);
[i1,j1,k1] = ind2sub(sz,vec1);

vec2 = find(A3(:,:,1:t,1)==2);
[i2,j2,k2] = ind2sub(sz,vec2);

vec3 = find(A3(:,:,1:t,1)==4);
[i3,j3,k3] = ind2sub(sz,vec3);
 
vec4 = find(A3(:,:,1:t,1)>4);
[i4,j4,k4] = ind2sub(sz,vec4);



% === draw ===

anzgran = length (vec2) + length(vec4) + length(vec3);% + length(vec5);
handles.anzgran = anzgran;

if 1
%=
% view(2)
view(90,-90);
ax = handles.axes1;
hold on
if ~get(handles.actin_onoff,'Value')
h = scatter3(ax,i1,j1,k1,80,'s',...  
    'MarkerEdgeColor','k',...
    'MarkerFaceColor',[1 0 0]);
alpha(h,0.3);
end
b = scatter3(ax,i2,j2,k2,... %default no size (20)
    'MarkerEdgeColor','k',...
    'MarkerFaceColor',[0 0.5 0]);
for i = 1:length(vec3)
d =scatter3(ax,i3(i),j3(i),k3(i),randi([25,80]),... % 30,150 size of points, default no size
    'MarkerEdgeColor','k',...
    'MarkerFaceColor',[0.4 0.9 0.1880]);
alpha(d,0.8);
end
 
e = scatter3(ax,i4,j4,k4,'filled',... 
    'MarkerEdgeColor','k',...
    'MarkerFaceColor',[0 0.5 0]);
set(gca,'ZLim',[0 t]);
set(gca,'Color','k')
alpha(b,0.5);
alpha(e,0.5);

hold off
end

    % === Incrementing the control variable=====================
    count = count + 1;
    % ==========================================================

    glucose = get(handles.slider_gluco, 'Value');
    kalium = get(handles.slider_kali, 'Value');

% === draw plots ===
addpoints(lol,count,insulin);
addpoints(gluc_line,count,glucose*50);
addpoints(kali_line,count,kalium*50);
drawnow

handles.count = count;

% === Check if/what experiment is to be evaluated === 
    if handles.Experiment == 1  % Biphasic behaviour
        if count <= 100
            set(handles.slider_gluco,'Value',17/100);
        elseif count > 100 && count <= 500
            set(handles.slider_gluco,'Value',1);
        elseif count > 500 && count <= 650
            set(handles.slider_gluco,'Value',17/100);
        elseif count > 650
            set(handles.automat,'Value',0);
            AuswertungPlotten(handles.Experiment,Auswertung);
        end
        
        Auswertung(count,1) = insulin;
        Auswertung(count,2) = glucose;
        
    elseif handles.Experiment == 2 % first kalium then glucose stimulation
        set(handles.tirf_t,'String','8');
        if count <= 100
            set(handles.slider_gluco,'Value',0);
        elseif count > 100 && count <=200
            set(handles.slider_kali,'Value',40/100);
        elseif count > 200 && count <=300
            set(handles.slider_kali,'Value',0);
        elseif count > 300 && count <=400
            set(handles.slider_gluco,'Value',30/100);
        elseif count > 400 && count <=500
            set(handles.slider_gluco,'Value',0);
        elseif count > 500
            set(handles.automat,'Value',0);
            AuswertungPlotten(handles.Experiment,Auswertung);
        end
        
        Auswertung(count,1) = insulin;
        Auswertung(count,2) = anzgranRandschicht;
        Auswertung(count,3) = glucose;
        Auswertung(count,4) = kalium;
        
    elseif handles.Experiment == 3 % first glucose then kalium stimulation
        set(handles.tirf_t,'String','8');
        if count <= 100
            set(handles.slider_gluco,'Value',3/100);
        elseif count > 100 && count <=200
            set(handles.slider_gluco,'Value',30/100);
        elseif count > 200 && count <=300
            set(handles.slider_gluco,'Value',3/100);
        elseif count > 300 && count <=400
            set(handles.slider_kali,'Value',40/100);
            set(handles.slider_gluco,'Value',0);
        elseif count > 400 && count <=500
            set(handles.slider_kali,'Value',0);
            set(handles.slider_gluco,'Value',3/100);
        elseif count > 500
            set(handles.automat,'Value',0);
            AuswertungPlotten(handles.Experiment,Auswertung);
        end
        
        Auswertung(count,1) = insulin;
        Auswertung(count,2) = anzgranRandschicht;
        Auswertung(count,3) = glucose;
        Auswertung(count,4) = kalium;
        
    elseif handles.Experiment == 4 %controll stimulus
        set(handles.tirf_t,'String','8');
        if count <= 600
            set(handles.slider_gluco,'Value',3/100);
        elseif count > 600
            set(handles.automat,'Value',0);
            AuswertungPlotten(handles.Experiment,Auswertung);
        end
        
        Auswertung(count,1) = insulin;
        Auswertung(count,2) = glucose;
        Auswertung(count,3) = anzgranRandschicht;
        
    elseif handles.Experiment == 5 %test
        if count <= 100
            set(handles.slider_gluco,'Value',0.25);
            set(handles.slider_kali,'Value',0);
        elseif count > 100 && count <= 200
            set(handles.slider_gluco,'Value',0);
        elseif count > 200 && count <= 300
            set(handles.slider_kali,'Value',0.25);
        elseif count > 300 && count <= 400
            set(handles.slider_kali,'Value',0);
        elseif count > 400 && count <= 500
            set(handles.slider_gluco,'Value',0.15);
            set(handles.slider_kali,'Value',0.07);
        elseif count > 500 && count <= 600
            set(handles.slider_gluco,'Value',0);
            set(handles.slider_kali,'Value',0);
        elseif count > 700
            set(handles.automat,'Value',0);
            AuswertungPlotten(handles.Experiment,Auswertung);
        end
        
        Auswertung(count,1) = glucose;
        Auswertung(count,2) = kalium;
        Auswertung(count,3) = handles.Stimulation_ist;
        
    elseif handles.Experiment == 6 %test
        if count <= 10
            set(handles.slider_gluco,'Value',5/100);
        elseif count > 10 && count <= 40
            set(handles.slider_gluco,'Value',1);
        elseif count > 40 && count <= 60
            set(handles.slider_gluco,'Value',5/100);
        elseif count > 60
            set(handles.automat,'Value',0);
            AuswertungPlotten(handles.Experiment,Auswertung);
        end
        
        Auswertung(count,1) = insulin;
        Auswertung(count,2) = glucose;
    end


    %Update and Safe
    handles.count = count;
    handles.plots = plots;
    handles.ZA3 = A3;
    handles.glucose = glucose;
    handles.kalium = kalium;
    guidata(hObject,handles);
    pause(0.05);
end



function tirf_t_Callback(hObject, eventdata, handles)
% hObject    handle to tirf_t (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of tirf_t as text
%        str2double(get(hObject,'String')) returns contents of tirf_t as a double


% --- Executes during object creation, after setting all properties.
function tirf_t_CreateFcn(hObject, eventdata, handles)
% hObject    handle to tirf_t (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton39.
function pushbutton39_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton39 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
latrun = get(handles.slider_latrun, 'Value');
ZB = handles.ZB3;
[x,y,z] = size(ZB(:,:,:,1));
% C = zeros(x,y,z,1);
% C = ZB;
%=====Algorithmus 1
for i = 1:x
    for j = 1:y
        for k = 1:z
            if ZB(i,j,k,1) == 1
                if rand < latrun
                    ZB(i,j,k,1) = 0;
                end
            end
        end
    end
end

%====Zeichnen
sz = [x y z];
vec1 = find(ZB(:,:,:,1)==1);
[i1,j1,k1] = ind2sub(sz,vec1);

h = scatter3(i1,j1,k1,80,'s',...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor',[1 0 0]);
alpha(h,0.1);
                                    
                                    
handles.ZB3 = ZB;
guidata(hObject, handles);


% --- Executes on button press in move2.
function move2_Callback(hObject, eventdata, handles)
% hObject    handle to move2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
plots = handles.plots;
count = handles.count;
q = get(handles.popupmenu2, 'UserData');

try
switch get(handles.popupmenu2, 'UserData')
    case 1
        num = 1;
        label = 'Insulin output';
    case 2
        num = 2;
        label = 'Number of all granules in cell [%]';
    otherwise
        num = 3;
        label = 'Number of granules in edge layer';
end
catch
    num = 1;
    label = 'Insulin output';
end


fig = figure;
hold on
yyaxis left
plot(plots(1:count,num));
ylabel(label);
% set(gca,'YLim',[50 102]);
yyaxis right
plot(plots(1:count,4));
plot(plots(1:count,5));
set(gca,'YLim',[0 1.5]);
ylabel('Stimulation');

xlabel('Timesteps');

legend('Insulin','Glucose','Kalium');

hold off


% --- Executes on selection change in popupmenu2.
function popupmenu2_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu2
switch get(handles.popupmenu2,'Value')
    case 1
        v = 1;
    case 2
        v = 2;
    otherwise
        v = 3;
end
set(handles.popupmenu2, 'UserData', v);


% --- Executes during object creation, after setting all properties.
function popupmenu2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes on button press in ExperimentAuswertung.
function ExperimentAuswertung_Callback(hObject, eventdata, handles)
% hObject    handle to ExperimentAuswertung (see GCBO) eventdata  reserved
% - to be defined in a future version of MATLAB handles    structure with
% handles and user data (see GUIDATA)

%Globale Variable Experiment setzen
if handles.Experiment < 6
    handles.Experiment = handles.Experiment + 1;
    handles.ExperimentAuswertung.String = ['Experiment ' int2str(handles.Experiment)];
else
    handles.Experiment = 0;
    handles.ExperimentAuswertung.String = 'Experiment = Aus';
end

if handles.Experiment == 1
    handles.ExperimentAuswertung.String = ['Exp: Biphasisches Verhalten'];
elseif handles.Experiment == 2
    handles.ExperimentAuswertung.String = ['Exp: 40 Ka | 30 Gluc'];
elseif handles.Experiment == 3
    handles.ExperimentAuswertung.String = ['Exp: 30 Gluc | 40 Ka'];
elseif handles.Experiment == 4
    handles.ExperimentAuswertung.String = ['Exp: Kontrollanregung 3 Gluc'];
elseif handles.Experiment == 5
    handles.ExperimentAuswertung.String = ['Test 1'];
elseif handles.Experiment == 6
    handles.ExperimentAuswertung.String = ['Test 2'];
end

guidata(hObject,handles);

