function [anzahl_x,anzahl_y,anzahl_z,chd_x,chd_y,chd_z] = chord_length_3d(A)

%% this is an algorithm to determine the chord length distribution of a 3D actin net

% === Matrix Gre ermitteln und Ausgabematrizen erstellen ===
[x,y,z] = size(A);
length_x = zeros(x,ceil(x/2)); % Matrix nicht unntig gro machen, deswegen mit ceil
length_y = zeros(y,ceil(y/2)); % Maximal mgliche Anzahl an Chords ist Hlfte der Lnge
length_z = zeros(z,ceil(z/2)); % --> vorhandene Lngen in der Richtung
ch_numx = zeros(y*z,1);
ch_numy = zeros(x*z,1);
ch_numz = zeros(x*y,1);
anzahl_x = zeros(y+1,1); %+1 damit der Plot spter besser aussieht
anzahl_y = zeros(x+1,1);
anzahl_z = zeros(z+1,1);


% === chord length in x-direction ===
count = 0;
for j=1:y
    for k=1:z
        count = count + 1;
        if A(1,j,k) == 0
        	ch_numx(count) = 1;
            length_x(count,1) = 1;
        end
        for i=2:x
            if A(i,j,k) == 0 && A(i-1,j,k) ~= 0  %dieses Feld Fluid aber das davor kein Fluid
                ch_numx(count) = ch_numx(count) + 1;  %nchsten Chord erffnen
                length_x(count,ch_numx(count)) = 1;   %Startchordlnge auf eins setzen
            end
            if A(i,j,k) == 0 && A(i-1,j,k) == 0  %dieses Feld Fluid und das davor Fluid
                length_x(count,ch_numx(count)) = length_x(count,ch_numx(count)) + 1; %Chordlnge fr diesen Chord um einen erhht
            end
        end
    end
end


% === chord length in y-direction ===
count = 0;
for i=1:x
    for k=1:z
        count = count + 1;
        if A(i,1,k) == 0
        	ch_numy(count) = 1;
            length_y(count,1) = 1;
        end
        for j=2:y
            if A(i,j,k) == 0 && A(i,j-1,k) ~= 0  %dieses Feld Fluid aber das davor kein Fluid
                ch_numy(count) = ch_numy(count) + 1;  %nchsten Chord erffnen
                length_y(count,ch_numy(count)) = 1;   %Startchordlnge auf eins setzen
            end
            if A(i,j,k) == 0 && A(i,j-1,k) == 0  %dieses Feld Fluid und das davor Fluid
                length_y(count,ch_numy(count)) = length_y(count,ch_numy(count)) + 1; %Chordlnge fr diesen Chord um einen erhht
            end
        end
    end
end


% === chord length in z-direction ===
count = 0;
for i=1:x
    for j=1:y
        count = count + 1;
        if A(i,j,1) == 0
        	ch_numz(count) = 1;
            length_z(count,1) = 1;
        end
        for k=2:z
            if A(i,j,k) == 0 && A(i,j,k-1) ~= 0  %dieses Feld Fluid aber das davor kein Fluid
                ch_numz(count) = ch_numz(count) + 1;  %nchsten Chord erffnen
                length_z(count,ch_numz(count)) = 1;   %Startchordlnge auf eins setzen
            end
            if A(i,j,k) == 0 && A(i,j,k-1) == 0  %dieses Feld Fluid und das davor Fluid
                length_z(count,ch_numz(count)) = length_z(count,ch_numz(count)) + 1; %Chordlnge fr diesen Chord um einen erhht
            end
        end
    end
end


%===============================================================
%Zusammenzhlen, wie viele Chords von welcher Lnge es gibt
%drei for-schleifen, falls Gitterlngen ungleich
[m,n] = size(length_x);
for i = 1:m
    for j = 1:n
        if length_x(i,j) ~= 0
            a = length_x(i,j);
            anzahl_y(a) = anzahl_y(a) + 1;
        end
    end
end
[m,n] = size(length_y);
for i = 1:m
    for j = 1:n
        if length_y(i,j) ~= 0
            a = length_y(i,j);
            anzahl_x(a) = anzahl_x(a) + 1;
        end
    end
end
[m,n] = size(length_z);
for i = 1:m
    for j = 1:n
        if length_z(i,j) ~= 0
            a = length_z(i,j);
            anzahl_z(a) = anzahl_z(a) + 1;
        end
    end
end


% === Gesamt- und Durchschnittslnge der Chords bestimmen ===
% lenx --> Gesamtlnge aller Chords
% count1 --> Gesamtanzahl an Chords
% chl_x --> Chordlngenverteilung
% chd_x --> Durchschnittslnge Chords

lenx = 0;
leny = 0;
lenz = 0;
count1 = 0;
for i = 1:length(anzahl_x)
    if anzahl_x(i) ~= 0
        count1 = count1 + anzahl_x(i);
        lenx = lenx + anzahl_x(i)*i;
    end
end
count2 = 0;
for i = 1:length(anzahl_y)
    if anzahl_y(i) ~= 0
        count2 = count2 + anzahl_y(i);
        leny = leny + anzahl_y(i)*i;
    end
end   
count3 = 0;
for i = 1:length(anzahl_z)
    if anzahl_z(i) ~= 0
        count3 = count3 + anzahl_z(i);
        lenz = lenz + anzahl_z(i)*i;
    end
end     

chd_x = lenx/count1;
chd_y = leny/count2;
chd_z = lenz/count3;

%uisave({'anzahl_x','anzahl_y','anzahl_z'},'D:\Nextcloud\Chaos\Studium\Master\Studienarbeit\Analyse_Experimente\Chords_');

end
